--- a/configure.ac
+++ b/configure.ac
@@ -338,37 +338,24 @@
                                       [AC_MSG_ERROR([header file <security/pam_appl.h> or <pam/pam_appl.h> is required for PAM.])])])
 fi
 
-AC_ARG_WITH(memcached,
-    [  --with-memcached=DIR     site header files for libmemcached in DIR],
-    [
-  case "$withval" in
-  "" | y | ye | yes | n | no)
-      AC_MSG_ERROR([*** You must supply an argument to the --with-memcached option.])
-    ;;
-    *)
-
-  MEMCACHED_INCLUDE_DIR="$withval"/include
-  MEMCACHED_LIB_DIR="$withval"/lib
-  OLD_CFLAGS="$CFLAGS"
-  CFLAGS="$CFLAGS -I$MEMCACHED_INCLUDE_DIR"
-    AC_CHECK_HEADERS(
-      [libmemcached/memcached.h],
-        [AC_DEFINE([USE_MEMCACHED], 1, [Define to 1 to build with memcached support])],
-        [AC_MSG_ERROR([header file <libmemcached/memcached.h> is required for memcached support])])
-  CFLAGS=$OLD_CFLAGS
-  AC_CHECK_LIB(memcached, memcached_create, [], [AC_MSG_ERROR(libmemcached is not installed)])
-  MEMCACHED_INCLUDE_OPT="-I $MEMCACHED_INCLUDE_DIR"
-  MEMCACHED_LINK_OPT="-L$MEMCACHED_LIB_DIR"
-  MEMCACHED_RPATH_OPT="-rpath $MEMCACHED_LIB_DIR"
-  ;;
-  esac
-  ])
+AC_ARG_WITH([memcached],
+    AS_HELP_STRING([--with-memcached], [Build with memcached support]))
 
-CFLAGS="$CFLAGS -fno-strict-aliasing"
+AS_IF([test "x$with_memcached" = "xyes"], [
+   PKG_CHECK_MODULES([MEMCACHED], [libmemcached])
+   CFLAGS="$CFLAGS $MEMCACHED_CFLAGS"
+   LIBS="$LIBS $MEMCACHED_LIBS"
+
+   AC_CHECK_HEADERS(
+       [libmemcached/memcached.h],
+           [AC_DEFINE([USE_MEMCACHED], 1, [Define to 1 to build with memcached support])],
+           [AC_MSG_ERROR([Couldn't find <libmemcached/memcached.h>])])
+
+   AC_SEARCH_LIBS(memcached_create, [], [],
+       [AC_MSG_ERROR(libmemcached is not installed)])
+])
 
-AC_SUBST(MEMCACHED_INCLUDE_OPT)
-AC_SUBST(MEMCACHED_LINK_OPT)
-AC_SUBST(MEMCACHED_RPATH_OPT)
+CFLAGS="$CFLAGS -fno-strict-aliasing"
 
 OLD_LDFLAGS="$LDFLAGS"
 LDFLAGS="-L$PGSQL_LIB_DIR"
@@ -380,7 +367,6 @@
 
 AC_SUBST(PGSQL_INCLUDE_DIR)
 AC_SUBST(PGSQL_LIB_DIR)
-AC_SUBST(MEMCACHED_DIR)
 
 # --enable(disable)-rpath option
 AC_ARG_ENABLE(rpath,
